
#include <hglcd.h>
#include <pic.h>
#include <hgdelay.h>
#define Design "FLEXICONTROL"
#define Version	"Version 1.01 2007"


//--------------------------------------------------------------------
void lcd_affiche (const unsigned char *str)
{
	unsigned char carac=0;
	do
	{
		if (str[carac]!=0)
			{
				lcd_send(str[carac]);
				carac++;
			}
	}
	while(str[carac]!=0);
}
//------------------------------------------------------------
void BinToChar (unsigned char Data,unsigned char *str,unsigned char Midi)
{
	if (!Midi)
	{
		str[0]=(Data/100)+'0';
	}
	
	Data = Data %100;
	str[1-Midi]= (Data/10)+'0';
	str[2-Midi]=(Data%10)+'0';
	str[3-Midi]=0;
}
//-------------------------------------------------------------

void lcd_midi(unsigned char Midi)
{
	static unsigned char Dest[3];
	BinToChar(Midi+1,Dest,1);
	lcd_bfcmd(0xC0);			//locate le curseur a 2e ligne premiere 3e espace
	lcd_affiche("MidiCh ");
	lcd_affiche(Dest);
	lcd_bfcmd(0x82);
	
}
//----------------------------------------------------------------
void lcd_prog(unsigned char Prog)
{	
	static unsigned char Dest2[4];
	BinToChar(Prog+1,Dest2,0);
	lcd_bfcmd(0xCB);			//locate le curseur a 2e ligne premiere 3e espace
	lcd_affiche("PgmCh ");
	lcd_affiche(Dest2);
	lcd_bfcmd(0x82);
}
//----------------------------------------------------------------
void lcd_mexpr(unsigned char MExpr)
{	
	static unsigned char Dest3[3];
	BinToChar(MExpr+1,Dest3,1);
	lcd_bfcmd(0xCB);			//locate le curseur a 2e ligne premiere 3e espace
	lcd_affiche("MIDI Exp ");
	lcd_affiche(Dest3);
	lcd_bfcmd(0x82);
}
//----------------------------------------------------------------
void lcd_expr(unsigned char Expr)
{	
	static unsigned char Dest4[4];
	BinToChar(Expr+1,Dest4,0);
	lcd_bfcmd(0xCB);			//locate le curseur a 2e ligne premiere 3e espace
	lcd_affiche("Exp Mode ");
	lcd_affiche(Dest4);
	lcd_bfcmd(0x82);
}

//--------------------------------------------------------------------
void lcd_preset(unsigned char Selection)
{
	unsigned char Preset[3];
	BinToChar(Selection,Preset,1);
	lcd_bfcmd(0xC0);			//locate le curseur a 2e ligne premiere 1e espace
	//lcd_affiche("P");
	lcd_affiche(Preset);
	lcd_bfcmd(0x10);					//recule d'une espace
	lcd_bfcmd(0x10);					//recule d'une espace
	lcd_affiche("P");	
}
//--------------------------------------------------------------------
void lcd_bank(unsigned char Bank)
{
	unsigned char Preset[2];
	BinToChar(Bank,Preset,1);
	lcd_bfcmd(0xD2);			//locate le curseur a 2e ligne premiere 3e espace
	//lcd_affiche("B");
	lcd_affiche(Preset);
	lcd_bfcmd(0x10);					//recule d'une espace
	lcd_bfcmd(0x10);					//recule d'une espace
	lcd_affiche("B");
}
//--------------------------------------------------------------------
//#pragma interrupt_level 1
void lcd_buzflag(void)
{
	char Busy;
	PORTSET=0xFF;			//met portd en input
	do
	{	
		RS=0;				//set rs pour une commande
		RW=1;				//commaqnde pour lire
		E=1;				// a besoin d,Un front descendant sur Enable 
		Busy=PORTIO;		//met la valeur du port d dans busy
		E=0;
	}
	while(Busy&0x80);
		PORTSET=0x00;		//met portd en sorties
}
//------------------------------------------------------------

unsigned char lcd_dataget(void)
{
	char Dget;
	PORTSET=0xFF;			//met portd en input
	RS=1;					//set rs pour une data
	RW=1;					//commande pour lire
	E=1;					// a besoin d,Un front descendant sur Enable 
	Dget=PORTIO;			//met portd sur Dget
	E=0;
	PORTSET=0x00;			//met portd en sorties			
	return Dget;
}
//------------------------------------------------------------
void lcd_cmd (unsigned char Cmd)
{	
	RS=0;             		//set rs pour une commande  
	RW=0;					//commaqnde pour ecrire
	E=1;					// a besoin d,Un front descendant sur Enable 
	PORTIO=Cmd;				//portd egal Cmd
	E=0;	
}
//------------------------------------------------------------
void lcd_bfcmd (unsigned char Tcmd)
{
	lcd_buzflag();			//verifi le buzflag
	lcd_cmd(Tcmd);			//envoie la commande Tcmd
}
//------------------------------------------------------------
//#pragma interrupt_level 1
void lcd_send (unsigned char Car)
{
	lcd_buzflag();			//verifi le buzflag
	RW=0;					//commaqnde pour ecrire
	RS=1;					//set rs pour une data
	E=1;  					// a besoin d,Un front descendant sur Enable 
	PORTIO=Car;				//portd egale Car
	E=0;	
}
//------------------------------------------------------------
void lcd_init (void)
{
	ADCON1=0x06;
 	TRISE=0x00;					//porte en sortie
  	PORTSET=0x00;				//set le portd en sortie
	LongDelay(60);
	lcd_cmd(0x38);				//function set 1 ligne,5x7dots,8bit data 
	LongDelay(20);
	lcd_cmd(0x38);				//function set 1 ligne,5x7dots,8bit data 
	Delay(30);
	lcd_cmd(0x38);				//function set 1 ligne,5x7dots,8bit data 

	lcd_bfcmd(0x38);			//function set 1 ligne,5x7dots,8bit data 
	lcd_bfcmd(0x0C);			//display on
	lcd_bfcmd(0x01);			//clear display
	lcd_bfcmd(0x06);			//set pour ecrementer le curseur apres chaque ecriture
	lcd_bfcmd(0x80);			//locate le curseur a premiere ligne premiere espace
}
//------------------------------------------------------------
unsigned char up_change(unsigned char Data)
{
	Data=Data+1;				//incremente data
	if (Data<0x30)				//si data est plus petit que '0'
	{
		Data=0x30;				//Data egale '0'
	}
	if ((Data>0x39)&&(Data<0x41))	//si Data est plus grand que '9' et plus petit que 'A'
	{
		Data=0xA0;					//Data egale 'espace'
	}
	if (Data>0xA0)					//si Data egale 'espace'
	{
		Data=0x41;					//Data egale'A'
	}
    if ((Data>0x5A)&&(Data<0xA0))	//si Data est plus grand que 'Z' et plus petit que 'espace'
    {
        Data=0x30;					//Data egale'0'
    }
   return Data;
}
//-----------------------------------------------------------------------
unsigned char dwn_change(unsigned char Data)
{
	Data=Data-1;
	if ((Data<0x41)&&(Data>0x39))			//si Data est plus petit que 'A' et plus grand que '9'
	{
		Data=0xA0;							//Data egale 'espace'
	}
	if (Data<0x30)							//si data est plus petit que '0'
	{
		Data=0x5A;							//Data egale 'Z'
	}
	if ((Data<0xA0)&&(Data>0x5A))			//si Data est plus petit que 'espace' et plus grand que 'Z'
	{
		Data=0x39;							//Data egale'9'
	}
	if (Data>0xA0)							//si data est plus grand que 'espace'
	{
		Data=0x5A;							//Data egale'Z'
	}
	 return Data;

}
//-------------------------------------------------------------------------
unsigned char up_caract (unsigned char Data)
 	  {
        byte Data2;
		Data2=(up_change(Data));			//Incremente le caractere
		lcd_send(Data2);					//affiche le nouveau caractere
		lcd_bfcmd(0x10);					//recule d'une espace
		return Data2;
	  }
//--------------------------------------------------------------------------
unsigned char dwn_caract (unsigned char Data)
 	  {
		Data=(dwn_change(Data));			//decremente le caractere
		lcd_send(Data);						//affiche le nouveau caractere
		lcd_bfcmd(0x10);					//recule d'une espace
		return Data;
	  }
//---------------------------------------------------------------------------
unsigned char rgt_mov (unsigned char Data)
 	  {
		lcd_bfcmd(0x14);					//avance d'une espace
		lcd_bfcmd(0x14);					//avance d'une espace
		Data=(lcd_dataget());				//met la donne du caractere dans Data
		if (Data==0x20)						//si data egale'espace' 20
		{
			Data=0xA0;						//Data egale 'espace'A0
		}
		lcd_bfcmd(0x10);					//recule d'une espace
		return Data;
	  }
//---------------------------------------------------------------------------
unsigned char lft_mov (unsigned char Data)
 	  {
			
		lcd_bfcmd(0x10);					//recule d'une espace
		lcd_bfcmd(0x10);					//recule d'une espace
		Data=(lcd_dataget());				//met la donne du caractere dans Data
		if (Data==0x20)						//si data egale'espace' 20
		{
			Data=0xA0;						//Data egale 'espace'A0
		}	
		lcd_bfcmd(0x14);					//avance d'une espace		
		return Data;		
	  }
//---------------------------------------------------------------------------
void design(void)		//envoie les 16 premiere adresses en program et les 16 suivant les caractere au lcd
{
	lcd_bfcmd(0x01);			//clear display	
	lcd_bfcmd(0x83);			//locate le curseur a premiere ligne troisieme espace
	lcd_affiche(Design);			//
	lcd_bfcmd(0xC1);			//locate le curseur a premiere ligne troisieme espace
	lcd_affiche(Version);		//affiche la version
	LongDelay(10000);
	
}
//---------------------------------------------------------------------------
